# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from uuv_control_msgs/GoToRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import uuv_control_msgs.msg
import std_msgs.msg

class GoToRequest(genpy.Message):
  _md5sum = "ca7b4067b6783823c9f5c936e1c99b3a"
  _type = "uuv_control_msgs/GoToRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """














string LIPB='lipb'
string CUBIC='cubic'
string DUBINS='dubins'
string LINEAR='linear'

uuv_control_msgs/Waypoint waypoint
float64 max_forward_speed
string interpolator

================================================================================
MSG: uuv_control_msgs/Waypoint
# Copyright (c) 2016 The UUV Simulator Authors.
# All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

std_msgs/Header header
geometry_msgs/Point point
float64 max_forward_speed
float64 heading_offset
bool use_fixed_heading
float64 radius_of_acceptance

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  # Pseudo-constants
  LIPB = r"'lipb'"
  CUBIC = r"'cubic'"
  DUBINS = r"'dubins'"
  LINEAR = r"'linear'"

  __slots__ = ['waypoint','max_forward_speed','interpolator']
  _slot_types = ['uuv_control_msgs/Waypoint','float64','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       waypoint,max_forward_speed,interpolator

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GoToRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.waypoint is None:
        self.waypoint = uuv_control_msgs.msg.Waypoint()
      if self.max_forward_speed is None:
        self.max_forward_speed = 0.
      if self.interpolator is None:
        self.interpolator = ''
    else:
      self.waypoint = uuv_control_msgs.msg.Waypoint()
      self.max_forward_speed = 0.
      self.interpolator = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.waypoint.header.seq, _x.waypoint.header.stamp.secs, _x.waypoint.header.stamp.nsecs))
      _x = self.waypoint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_5dB2d().pack(_x.waypoint.point.x, _x.waypoint.point.y, _x.waypoint.point.z, _x.waypoint.max_forward_speed, _x.waypoint.heading_offset, _x.waypoint.use_fixed_heading, _x.waypoint.radius_of_acceptance, _x.max_forward_speed))
      _x = self.interpolator
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.waypoint is None:
        self.waypoint = uuv_control_msgs.msg.Waypoint()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.waypoint.header.seq, _x.waypoint.header.stamp.secs, _x.waypoint.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.waypoint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.waypoint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.waypoint.point.x, _x.waypoint.point.y, _x.waypoint.point.z, _x.waypoint.max_forward_speed, _x.waypoint.heading_offset, _x.waypoint.use_fixed_heading, _x.waypoint.radius_of_acceptance, _x.max_forward_speed,) = _get_struct_5dB2d().unpack(str[start:end])
      self.waypoint.use_fixed_heading = bool(self.waypoint.use_fixed_heading)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.interpolator = str[start:end].decode('utf-8')
      else:
        self.interpolator = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.waypoint.header.seq, _x.waypoint.header.stamp.secs, _x.waypoint.header.stamp.nsecs))
      _x = self.waypoint.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_5dB2d().pack(_x.waypoint.point.x, _x.waypoint.point.y, _x.waypoint.point.z, _x.waypoint.max_forward_speed, _x.waypoint.heading_offset, _x.waypoint.use_fixed_heading, _x.waypoint.radius_of_acceptance, _x.max_forward_speed))
      _x = self.interpolator
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.waypoint is None:
        self.waypoint = uuv_control_msgs.msg.Waypoint()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.waypoint.header.seq, _x.waypoint.header.stamp.secs, _x.waypoint.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.waypoint.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.waypoint.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.waypoint.point.x, _x.waypoint.point.y, _x.waypoint.point.z, _x.waypoint.max_forward_speed, _x.waypoint.heading_offset, _x.waypoint.use_fixed_heading, _x.waypoint.radius_of_acceptance, _x.max_forward_speed,) = _get_struct_5dB2d().unpack(str[start:end])
      self.waypoint.use_fixed_heading = bool(self.waypoint.use_fixed_heading)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.interpolator = str[start:end].decode('utf-8')
      else:
        self.interpolator = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_5dB2d = None
def _get_struct_5dB2d():
    global _struct_5dB2d
    if _struct_5dB2d is None:
        _struct_5dB2d = struct.Struct("<5dB2d")
    return _struct_5dB2d
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from uuv_control_msgs/GoToResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GoToResponse(genpy.Message):
  _md5sum = "358e233cde0c8a8bcfea4ce193f8fc15"
  _type = "uuv_control_msgs/GoToResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool success

"""
  __slots__ = ['success']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       success

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GoToResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.success is None:
        self.success = False
    else:
      self.success = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_get_struct_B().pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_get_struct_B().pack(self.success))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.success,) = _get_struct_B().unpack(str[start:end])
      self.success = bool(self.success)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class GoTo(object):
  _type          = 'uuv_control_msgs/GoTo'
  _md5sum = '408446fa9ec1d90b38a7053e3dd0ad47'
  _request_class  = GoToRequest
  _response_class = GoToResponse
